## EDU.oswego.cs.dl.util.concurrent
Interface Puttable

All Known Subinterfaces:
  BoundedChannel, Channel

All Known Implementing Classes:
  BoundedBuffer, BoundedLinkedQueue, BoundedPriorityQueue, LinkedQueue, SemaphoreControlledChannel, Slot, SynchronousChannel, WaitFreeQueue

    public interface Puttable

This interface exists to enable stricter type checking for channels. A method argument or instance variable in a producer object can be declared as only a Puttable rather than a Channel, in which case a Java compiler will disallow take operations.

Full method descriptions appear in the Channel interface.

[ Introduction to this package. ]

See Also:
  `Channel`, `Takable`

Method Summary
`boolean` `offer(java.lang.Object item, long msecs)` Place item in channel only if it can be accepted within msecs milliseconds.
`void` `put(java.lang.Object item)` Place item in the channel, possibly waiting indefinitely until it can be accepted.

Method Detail

### put

    void put(java.lang.Object item)
             throws java.lang.InterruptedException

  Place item in the channel, possibly waiting indefinitely until it can be accepted. Channels implementing the BoundedChannel subinterface are generally guaranteed to block on puts upon reaching capacity, but other implementations may or may not block.

  Parameters:
    `item` - the element to be inserted. Should be non-null.
  Throws:
    `java.lang.InterruptedException` - if the current thread has been interrupted at a point at which interruption is detected, in which case the element is guaranteed not to be inserted. Otherwise, on normal return, the element is guaranteed to have been inserted.

### offer

    boolean offer(java.lang.Object item,
                  long msecs)
                  throws java.lang.InterruptedException

  Place item in channel only if it can be accepted within msecs milliseconds. The time bound is interpreted in a coarse-grained, best-effort fashion.

  Parameters:
    `item` - the element to be inserted. Should be non-null.
    `msecs` - the number of milliseconds to wait. If less than or equal to zero, the method does not perform any timed waits, but might still require access to a synchronization lock, which can impose unbounded delay if there is a lot of contention for the channel.
  Returns:
    true if accepted, else false
  Throws:
    `java.lang.InterruptedException` - if the current thread has been interrupted at a point at which interruption is detected, in which case the element is guaranteed not to be inserted (i.e., is equivalent to a false return).